/* topsnet.c */

#include <stdio.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>    
#include <string.h>  
#include <sys/types.h>
#include <signal.h>
#include <unistd.h>
#include <stdlib.h>
#include <fcntl.h>
#include <errno.h>
#include <dirent.h>
#include <sys/stat.h>



int main(int argc, char *argv[]) {
  struct sockaddr_in sin;
  struct sockaddr_in pin;
  int sock_descriptor;
  int temp_sock_descriptor;
  int address_size;
  char req_name[66], codereq_name[66];
  char datacatalyst_name[66], codedatacatalyst_name[66];
  char twodatacatalyst_name[66], lkdatacatalyst_name[66];
  char tmpname[66], userdirname[66]; 
  char downrootdir[66], uprootdir[66]; 

    
  int i, arg, len;

  /*********************************************/
   
   int passlength, passloop;
   FILE *input_file;
   FILE *output_file;
   FILE *datacatalyst_file;
   FILE *twodatacatalyst_file;
   FILE *lkdatacatalyst_file;
     
    
   char *tmpuprootdir;
   char *tmpdownrootdir;
   char *varcatdir;
   int servermode;
   char *password;
    
   char *sendflag;
 
   char key2[66], word[66];
      
   int loophelp, step, c, filesize, data, key2loophelp;
   int req_namelength, namedata;
   int codenamelength;

   int enc1offset, encloop;
   int nonedata;

   int dirnamelength, offset, length;
   
   unsigned long checksum1;
   unsigned long checksum2;
   unsigned long checksum3;
   unsigned long checksum4;
   char checksumsend[66];  
   char checksumget[66];
   int fdlock, tries;
 

  char dir[66];    /*vars for dir print */
  int cut, dirflag;
  DIR *dp;
  struct dirent *entry;
  char entryout[66];
  struct stat statbuf;


   int port;   
   int filebuf[600]; /* NOTE: filebuf and bufsize must be the same 
                          for loops to work and divisible/4 */
   int bufsize; 

   port=4333;  
   bufsize=600;
 
   

    if (argc != 6) 
    { printf("\n\n\n\n\n"); 
      printf("\nTOPSECRET-NET  by SIVA R. KRISHNA (C) 2000 V0.90beta");    
      printf("\n\nLicensed as shareware, $10 for each client computer.");   
      printf("\n\nFor current registration and program questions,");
      printf("\n\nemail nomad01@fdn.com  ");
      printf("\n\n\n\nThis program is sold AS IS, no one or ");  
      printf("vendor shall be liable for \nspecial, incidental,consequential");
      printf(", direct, or indirect damages;\nfrom the use ");
      printf("or missuse of this program. Other liabilities for"); 
      printf("\ndamages shall in no event exceed the purchase price.");  
      printf("\n\n\n");  
 
      printf("\n\n\nExample usage=\n./topsnet"); 
      printf(" /topsnet/download/"); 
      printf(" /topsnet/upload/");     
      printf(" /topsnet/catalyst/"); 
      printf(" password");
      printf(" 3\n\n");
      printf("\nPlease see topsecret_net.txt"); 
      printf(" for detailed information.\n\n");
       exit(0); } 
    
  tmpdownrootdir = argv[1];
  tmpuprootdir = argv[2];
  varcatdir = argv[3];
  password = argv [4];
  servermode = (argv[5][0]);

  passlength = strlen(password); passloop= 0;
  
  if (strcmp(varcatdir, uprootdir) == 0 ) 
      { printf("\n For better security ``access root directory'' and
the ``catalyst directory'' should NOT be the same.\n\n");
        exit(0);} 
 if ((servermode!=49)&&(servermode!=50)&&(servermode!=51))
     {printf("\n Invalid servermode; \n1- serve topsget");
      printf("\n2- serve topssend");
      printf("\n3- serve both topsget and topssend\n"); 
       exit(0);}

 
  /*********************************************/

  sock_descriptor = socket(AF_INET, SOCK_STREAM, 0);
  if (sock_descriptor == -1) {
    perror("call to socket");
    exit(1);
  }

  bzero(&sin, sizeof(sin));
  sin.sin_family = AF_INET;
  sin.sin_addr.s_addr = INADDR_ANY;
  sin.sin_port = htons(port);

  if (bind(sock_descriptor, (struct sockaddr *)&sin, sizeof(sin)) == -1) {
    perror("call to bind");
    exit(1);
  }

  if (listen(sock_descriptor, 200) == -1) {
    perror("call to listen");
    exit(1);
  }

  printf("\n\ntopsnet accepting connections ...\n\n"); 
  signal(SIGCHLD, SIG_IGN); /*+++++++++*/

  while(1) {
    temp_sock_descriptor =
      accept(sock_descriptor, (struct sockaddr *)&pin,
	     &address_size);
    if (temp_sock_descriptor == -1) 
     {perror("call to accept"); exit(1); }

    if (fork()==0) {         /*+++++++++*/
 
/*++++++++++++++++++++++++++++++++++++++++++++++++++++*/
   /*-t printf("\n"); */ 

    for (i=0; i< 66; i++) {/* printf(" %d- %c",i,codereq_name[i]); */
                 codereq_name [i] = 0;
                           }     
      if (recv(temp_sock_descriptor, codereq_name, 66, 0) == -1) 
       { perror("call to recv"); exit(1); }


    for (i=0; i< 66; i++) {  datacatalyst_name[i] = 0;
                              }     
     if (recv(temp_sock_descriptor, datacatalyst_name, 66, 0) == -1) 
       { perror("call to recv"); exit(1); } 

   
   /* get usr dir first three letters and ``/'' assume */
   datacatalyst_name[3]= 47;  /*--- `/'------*/
   for (i=0; i< 4; i++) {userdirname[i]= datacatalyst_name[i];}
   userdirname[4]=0;

   strcpy(downrootdir, tmpdownrootdir);
   strcat(downrootdir, userdirname);

   strcpy(uprootdir, tmpuprootdir);
   strcat(uprootdir, userdirname);
  
/*  printf("\ndatacatalyst_name= %s", datacatalyst_name);
    printf("\nuserdirname= %s", userdirname);
    printf("\ndownrootdir= %s", downrootdir);
    printf("\nlength of downrootdir= %d", strlen(downrootdir)); 
    printf("\nuprootdir= %s\n", uprootdir);
    printf("\nlength of uprootdir= %d", strlen(uprootdir)); */ 
    
  
 sendflag="hkhkkkhhhrhrrrhh";        
 if(strstr(datacatalyst_name, sendflag) != NULL )
         { goto servesend;}
 
   if (servermode == 50)
   {printf("\n Currently serving topssend only."); 
      datacatalyst_name[4]=35; 
    if (send(temp_sock_descriptor, datacatalyst_name, 10, 0) == -1) 
      { perror("\ncall to send server status 50 fail"); goto close0;}
     goto close0;
    } 
/* cont serve topssget */
  
 if (send(temp_sock_descriptor, datacatalyst_name, 10, 0) == -1) 
     { perror("\ncall to send server status not 50 fail"); goto close0;}
 
/*-t printf("\nServing topsget"); */
/*%%%%%start to serve topsget client %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/
    
     if ((strlen(codereq_name)+strlen(uprootdir))>63)
         { printf("\nToo many characters in requested file name."); 
           printf("\n %s ", codereq_name); goto close1;} 
 

     if ((strlen(datacatalyst_name)+strlen(uprootdir))>63)
         { printf("\nToo many characters in datacatalyst file name."); 
           printf("\n %s ", datacatalyst_name); goto close1; }
      
/****put varcatdir in front of datacatalyst_name***********/
     
    for (i=0; i< 4; i++) 
     { lkdatacatalyst_name[i]= datacatalyst_name[i];}
    length = strlen(datacatalyst_name); /*make ldatacatalystname*/
    lkdatacatalyst_name[4]= 108;  /*--"l"--*/
    for (i=5; i< length+2; i++) 
     { lkdatacatalyst_name[i]= datacatalyst_name[i-1];}

    strcpy(tmpname, varcatdir);
    strcat(tmpname, lkdatacatalyst_name); /*add varcat dir */
    strcpy(lkdatacatalyst_name, tmpname);

    
    for (i=0; i< 4; i++) 
     { twodatacatalyst_name[i]= datacatalyst_name[i];}
    length = strlen(datacatalyst_name); /*make 2datacatalystname*/
    twodatacatalyst_name[4]= 116;  /*--"t"--*/
    for (i=5; i< length+2; i++) 
     { twodatacatalyst_name[i]= datacatalyst_name[i-1];}

    strcpy(tmpname, varcatdir);
    strcat(tmpname, twodatacatalyst_name); /*add varcat dir */
    strcpy(twodatacatalyst_name, tmpname);

    
    strcpy(tmpname, varcatdir);
    strcat(tmpname, datacatalyst_name); /*add varcat dir */
    strcpy(datacatalyst_name, tmpname);

/********/

       
/***********begin decoding file name***************************/

  for (i=0; i<66; i++)  /**init**/

   {  req_name[i]=0;  } 

datacatalyst_file = fopen (datacatalyst_name ,"rb"); 
   if (datacatalyst_file == NULL ) 
       { puts("\n***can't open datacatalyst_file file***");
         printf("\n %s",datacatalyst_name);     
                            goto close1; }
/*-t printf("\ndatacatalyst_name= %s", datacatalyst_name); */


   codenamelength= strlen(codereq_name);         
  /*-t printf("\nlength= %d\n",codenamelength); */ 
   for (i=0; i<codenamelength; i++) 
      {  namedata=getc(datacatalyst_file);
               if (namedata== EOF)  
               {fclose (datacatalyst_file); 
                datacatalyst_file =fopen (datacatalyst_name, "rb"); 
                namedata=getc(datacatalyst_file);  }

         req_name[i]=(codereq_name[i]^i)^(namedata);   
         if (req_name[i]==0) {req_name[i]=codereq_name[i];} 
         enc1offset=codereq_name[i]&30;

         encloop=0;
         while (encloop<enc1offset)  
          { namedata=getc(datacatalyst_file);
           if (namedata== EOF)  
               {fclose (datacatalyst_file); 
                 datacatalyst_file =fopen (datacatalyst_name, "rb"); 
                 namedata=getc(datacatalyst_file);
                }
              /*-t printf(" %d",enc1offset); */ 
              --enc1offset; 
            }
                      
         /*-t printf("\ncodereq_name[i]= %d", codereq_name[i]);
         printf(" codereq_name= %s", codereq_name);
         printf("\n    req_name[i]= %d", req_name[i]);
         printf("      req_name= %s\n", req_name); */
       }      


/***********end decoding file name******************************/
    
  
     
    strcpy(tmpname, downrootdir);
    strcat(tmpname , req_name); /*add root dir */
    strcpy(req_name, tmpname); 

    
/********/

    if(strstr(req_name, "//") != NULL )
    { printf("\n**Illegal ``//'' in or front of req_name file.**\n");
        printf("\nreq_name= %s ", req_name);
          goto close1;}

    if(strstr(req_name, "..") != NULL )
    { printf("\n**Illegal ``..'' in or front of req_name file.**\n");
        printf("\nreq_name= %s ", req_name);
          goto close1;}

    if(strstr(datacatalyst_name, "//") != NULL )
    { printf("\n**Illegal ``//'' in or front of datacatalyst_name file.**\n");
        printf("\ndatacatalyst_name= %s ", datacatalyst_name);
          goto close1;}
    
    if(strstr(datacatalyst_name, "..") != NULL )
    { printf("\n**Illegal ``..'' in or front of datacatalyst_name file.**\n"); 
        printf("\ndatacatalyst_name= %s ", datacatalyst_name);
          goto close1;}
    


/*********this routine gets dir info*************/

dirflag=0;
if(strstr(req_name, "topsdir.txt")==NULL) {goto endgetdir;}
dirflag=1;

  input_file = fopen(req_name,"wb");
    if (input_file == NULL ) 
         { puts("\n***can't open directory/topsdir.txt file***");         
           goto close0;    } 


  
  for (i=0; i<66; i++) { dir[i]=0; }     /**init**/
  cut=(strlen(req_name)- 11);
  strncpy(dir, req_name, cut); 
       
     if((dp = opendir(dir)) == NULL) 
       { fprintf(stderr, "cannot open directory: %s\n", dir);
           goto close0; }

       chdir (dir);
     /* printf("\n **directory= %s\n\n", dir); */

        printf("\nreq_name= %s",req_name);
        length=strlen(req_name);
        for (i=0; i<length; i++)
           { c =(req_name[i]);
             putc( c , input_file);
            }
        putc(10 , input_file); /* line feed */  

  while ((entry = readdir(dp)) != NULL)
   { stat(entry->d_name,&statbuf);

       if(S_ISDIR(statbuf.st_mode)) 
         { /* found a directory  */
         if (strcmp(".", entry->d_name) == 0||strcmp("..",entry->d_name) == 0)
                {continue;} /*ignore '.' or '..' */
          printf("\n%s/",entry->d_name); 
          length=strlen(entry->d_name);
              for (i=0; i<length; i++)
                { c =(entry->d_name[i]);
                  putc( c , input_file);
                 }
               putc(47 , input_file);  /* right-/  */
               putc(10 , input_file);   /* line feed */
               
         }

        else {if (strcmp("topsdir.txt", entry->d_name) == 0)
                {continue;} /* ignore 'tops.txt' */
              printf("\n%s",entry->d_name);
              length=strlen(entry->d_name);
              for (i=0; i<length; i++)
                { c =(entry->d_name[i]);
                  putc( c , input_file);
                 }
               putc(10 , input_file); /* line feed */
             }
   }
  chdir(uprootdir);  
  closedir(dp);
  fclose(input_file);

endgetdir:
/*******end routine get dir info ****************/



    dirnamelength = strlen(varcatdir); 
    i=0;
    while ( i<dirnamelength)  
     {  /* printf("\n i= %d",i );
           printf(" req_name[i]= %c", req_name[i]);
           printf(" varcatdir[i]= %c", varcatdir[i]); */
       if (req_name[i] != varcatdir[i]) { goto cont10;} 
        ++i; } 
     printf("\n**File read access from ``Variable Catalyst 
Directory'' is not allowed ! **\n");       
     printf("varcatdir= %s\n", varcatdir);  
      goto close1;

cont10:
/*    i=0;
    while ( i<dirnamelength)  
     {  printf("\n i= %d",i );
          printf(" datacatalyst_name[i]= %c", datacatalyst_name[i]);
          printf(" varcatdir[i]= %c", varcatdir[i]);  
        ++i; }  */
      
      /* printf("\n\n*******var cat******\n\n"); */ 
     
cont11:
     
/*****/

    printf("\nsend to client: %s", req_name);
    printf("\nusing datacatalyst_name: %s\n", datacatalyst_name);

           
    /*****************************************************/

tries=10;              /*** 10 seconds to see unlock ***/ 
   while (tries > 0) 
    {--tries;
     fdlock= open(lkdatacatalyst_name, O_RDWR | O_CREAT | O_EXCL, 0444); 
     if (fdlock!=-1) {goto nolock;} 
     
     sleep(1); printf("tries left= %d", tries);   
    }
  
  puts("\n***can't lock  datacatalyst file***"); 
  printf("\n\nlkdatacatalyst_name= %s", lkdatacatalyst_name);
  goto closelock; 
 nolock:
/********/
         
    input_file = fopen(req_name,"rb");
    if (input_file == NULL ) 
         { puts("\n***can't open input file***");
  printf("\ninput_file= %s", req_name);         
           goto close1;    } 

      
    datacatalyst_file = fopen (datacatalyst_name ,"rb"); 
    if (datacatalyst_file == NULL ) 
            { puts("\n***can't open datacatalyst file***");
                 printf("\n %s ", datacatalyst_name);             
                     goto close1; }


    key2loophelp=0;   /*generate first time key2 only */
     while (key2loophelp < passlength -1 )
         { key2[key2loophelp] = password[key2loophelp+1]; 
            ++ key2loophelp;} 
     key2[key2loophelp]= password [0] ;

    /*-t printf("\n +key2=     %s", key2);
     printf("\n +password= %s",password);
     printf("\n +passlength= %d\n", passlength); */ 


   /*-t printf("\nReading file: \n"); */
   loophelp=0; c=0; filesize=0;
   readfile:     
  while(( c= getc(input_file) ) != EOF) 
      { 
        data=getc(datacatalyst_file);
        if (data== EOF)  
           {fclose (datacatalyst_file); 
              datacatalyst_file =fopen (datacatalyst_name, "rb"); 
              data=getc(datacatalyst_file);  }
       
   word[passloop]=c;       
   data= (data^loophelp)^passloop;  /*hide data from simple code */   
             
     /* printf("\n data# before= %d ", data);
          printf("data char before= %c ", data); */
 
    data= data^password[passloop]; 
    data= data^key2[passloop];
    /* printf("\n data after= %d", data);
        printf(" password[passloop]=%c ", password[passloop]);
         printf(" passloop= %d ", passloop); */  
 
    /* printf("\n key2= %s", key2);
        printf("\n word= %s", word);
         printf("\n passlength= %d\n", passlength); */ 

  data= c^data;

         /**** catalyst offset for req file ****/
         enc1offset=c&3;
         encloop=0;
         while (encloop<enc1offset)  
          { nonedata=getc(datacatalyst_file);
           if (nonedata== EOF)  
               {fclose (datacatalyst_file); 
                 datacatalyst_file =fopen (datacatalyst_name, "rb"); 
                 nonedata=getc(datacatalyst_file);
                }
                  /* printf(" %d",enc1offset); */ 
              --enc1offset; 
            }
            /**** end catalyst offset for req file ****/

  if(data != EOF) {  filebuf[loophelp]= data; }
       else      { filebuf[loophelp] = c;  }
 

  passloop++; 
  if (passloop == passlength) 
       {
           for (i=0; i< passlength; i++) { key2[i]=word[i];}
                 passloop = 0 ;
        }   

         
    /* printf("%c",filebuf[loophelp]); */

          ++loophelp;
          ++filesize;
   
          if (loophelp < (bufsize/4) ) { goto readfile; }
          
          loophelp=0;
       
    /*test printf("\n0-loophelp is =%d",loophelp); 
     printf("\n0-filesize is = %d\n",filesize-1); */ 
       
            if (send(temp_sock_descriptor, filebuf, bufsize, 0) == -1) 
                 { perror("call to send"); exit(1); }
      
           /* close(temp_sock_descriptor); */ 
   
        }

          /* leftover data when input file done but buf not full*/
   /*-t printf("\n1-loophelp is =%d ",loophelp);
   printf("\n1-filesize is =%d \n",filesize);

   printf("\n0---ok---\n");
   printf("\nbufsize= %d\n", bufsize); */
          step=loophelp;
          while ( step <= bufsize/4) 
            {filebuf[step]= EOF; step = step +1;}       
       /*    filebuf[loophelp]=EOF;  don't use , use top three */   
  /*-t printf("\n1---ok---\n"); */ 	
         if (send(temp_sock_descriptor, filebuf, bufsize, 0) == -1) 
                 { perror("call to send"); exit(1); }
           
         
       
    
    /***************************************************/ 
    
 /*varcatmodevvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv*/  
      
  
  /*-t printf("\n datacatalyst name %s", datacatalyst_name);
  printf("\n twodatacatalyst name %s", twodatacatalyst_name);
  printf("\n length= %d", strlen(twodatacatalyst_name)); */
  
    fclose(input_file);
    fclose(datacatalyst_file); 

   input_file = fopen(req_name,"rb");
   if (input_file == NULL ) 
         { puts("\n***can't open input file for varcat***");
             printf("\nreq_name= %s ", req_name);         
            goto endvarcatmode;    } 

   datacatalyst_file = fopen (datacatalyst_name ,"rb"); 
   if (datacatalyst_file == NULL ) 
          { puts("\n***can't open datacatalyst file for varaat***");
              printf("\ndtatcatalyst_name= %s ", datacatalyst_name);          
                        goto endvarcatmode; }
    

   twodatacatalyst_file = fopen (twodatacatalyst_name ,"wb"); 
   if (twodatacatalyst_file == NULL ) 
     { puts("\n***can't write t-datacatalyst_name file***");
        printf("\ntwodatacatalyst_name= %s ", twodatacatalyst_name);
                                goto endvarcatmode; }  

  /*-t printf("\nchanging catalyst : \n"); */
  offset=0; 
  /* checksum=0; */ 
 while(( c = getc(datacatalyst_file) ) != EOF)
     {   /* checksum=checksum+c; */
         data=getc(input_file);
          if (data== EOF)  
              {fclose (input_file); 
                 input_file = fopen(req_name,"rb");
                 if (input_file == NULL ) 
                     { puts("\n***can't re-open input file for varcat***");
                        printf("\nreq_name= %s ", req_name);   
                             goto close1;}
                   data=getc(input_file);
                   if (data== EOF) { goto close1;}
                }
          
    
          --offset;   
          if (offset < 0) 
            { offset = (data&7);
                 /* printf("\noffset(databefore&7)= %x ", offset);
                     printf(" data= %x*%c ", data, data); */   
              data= data^c; 
                  /* printf(" dataafter(data^c)= %x ", data);
                      printf(" c= %x-%c \n",c ,c);  */

               if(data == EOF) { data = c; }
               putc( data , twodatacatalyst_file); 
                /* checksum=checksum+data; */                
   
             }
         else
          {  /* printf(" c# %x-%c ",c ,c ); */     
            putc( c, twodatacatalyst_file); 
             
               
          }

    }
    
 
   /*-t printf("\nreq_name= %s",req_name); */
    /* printf("\nchecksum= %ld", checksum); */ 
    
endvarcatmode:
/*endvarcatvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv*/

 /* checksum2 */ 
        
  checksum2=0; checksum3=0;

   fclose(input_file);
   input_file = fopen (req_name ,"rb"); 
   if (input_file == NULL ) 
   { puts("\n***can't read input file for checksum3***");
        printf("\nreq_name= %s ", req_name);
                                goto close0; }  
     while(( c = getc(input_file)) != EOF) 
        { checksum3=checksum3+c;}


   fclose(twodatacatalyst_file); 
  twodatacatalyst_file = fopen (twodatacatalyst_name ,"rb"); 
   if (twodatacatalyst_file == NULL ) 
     {puts("\n***can't read t-datacatalyst_name file for checksum2***");
         printf("\ntwodatacatalyst_name= %s ", twodatacatalyst_name);
                                goto close0; }  
  
     while(( c = getc(twodatacatalyst_file)) != EOF) 
        { checksum2=checksum2+c;}

  checksum1=checksum3+checksum2;
  /*-t printf("\nchecksum3= %ld", checksum3);  
  printf("\nchecksum2= %ld", checksum2);  
  printf("\nchecksum1= %d", checksum1); */
          
    	
/* end checksum2 */

/* send/get checksumx */

   
/*-t printf("\nsending checksum1 info. \n"); */
    
   sprintf(checksumsend, "%ld",checksum1);
   printf("\nchecksumsend = %s", checksumsend);    
 
          
   for (i=0; i< 66; i++) { checksumget[i] = 0; }     
   if (recv(temp_sock_descriptor, checksumget, 10, 0) ==-1)   
          { perror("\ncall to recv checksumget fail"); goto close0; } 
 

 printf("\nchecksumget=   %s",checksumget);     
 
 length= strlen(checksumsend);
 /*-t printf("\nlength= %d", length); */
 for (i=0; i< length; i++) 
 { if(checksumget[i] != checksumsend[i])
    {printf("\n checksum fail, bad file/transfer or bad catalyst.\n");
      printf("\nsleep 5\n"); sleep(5); 
      for (i=0; i<10; i++) {checksumsend[i]=69;}
      if (send(temp_sock_descriptor, checksumsend, 10, 0) == -1) 
           { perror("\ncall to send checksumsend fail"); goto close0; }
           goto close0;
     } 
  }
 
 if (send(temp_sock_descriptor, checksumsend, 10, 0) == -1) 
           { perror("\ncall to send checksumsend fail"); goto close0; }
      

/* end send/get checksumx */

/*start write updated datacatalyst*/

   
   fclose(datacatalyst_file); 
   datacatalyst_file = fopen (datacatalyst_name ,"wb"); 
   if (datacatalyst_file == NULL ) 
          { puts("\n***can't write datacatalyst file for update***");
              printf("\n %s ", datacatalyst_name);             
                     goto close1; }
    
   fclose(twodatacatalyst_file);
   twodatacatalyst_file = fopen (twodatacatalyst_name ,"rb"); 
   if (twodatacatalyst_file == NULL ) 
     { puts("\n***can't read t-datacatalyst_name for update***");
         printf("\ntwodatacatalyst_name %s ", twodatacatalyst_name);
                                goto close1; }  
 
  
 while(( c = getc(twodatacatalyst_file) ) != EOF) 
         { putc( c, datacatalyst_file); }   
 
/*end write updated datacatalyst*/

/* start verify written catalyst */
/*
checksum4=0;
   fclose(datacatalyst_file); 
   datacatalyst_file = fopen (datacatalyst_name ,"rb"); 
   if (datacatalyst_file == NULL ) 
          { puts("\n***can't read datacatalyst file for verify***");
              printf("\n %s ", datacatalyst_name); 
                  goto close1; }
     
   while(( c = getc(datacatalyst_file) ) != EOF) 
         { checksum4=checksum4+c; }

   if(checksum4 != checksum2)
      {printf("\n Error during catalyst verify.");        
       goto close1;}

*/
/* end verify written catalyst */

 close0:

   fclose(input_file);
   fclose(datacatalyst_file);
   fclose(twodatacatalyst_file);
    
 closelock:
   (void)close(fdlock);
   (void)unlink(lkdatacatalyst_name);
   /*-t printf("\ntries left= %d", tries); */
   
   close1:   
   if (dirflag==1)
    { if (remove(req_name)==0)
        {printf("\n %s list deleted", req_name);}
      else
         if(errno == ENOENT) 
          {printf("\n %s **list not found for deletion**", req_name);}       
      else
          {printf("\n %s **list access denied for deletion**", req_name);}
     }
   close(temp_sock_descriptor);
   
   /*-t printf("\nEnd-loophelp is =%d",loophelp); */ 
   printf("    filesize = %d \n",filesize);
   passloop=0; filesize=0; loophelp=0; dirflag=0;
 
   exit(0);   

/*@@@@start serving topssend client @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@*/
servesend:

 /*-t printf("\n ok it works"); 
 printf("\n server mode= %d", servermode); */

  if (servermode == 49)
   {printf("\n Currently serving topsget only."); 
     datacatalyst_name[0]=35;
    if (send(temp_sock_descriptor, datacatalyst_name, 66, 0) == -1) 
     { perror("\ncall to send server status 49 fail"); goto close10;}
     goto close10;      
    }  
/* cont serve topssend */
  
 if (send(temp_sock_descriptor, datacatalyst_name, 66, 0) == -1) 
    { perror("\ncall to send server status not 49 fail"); goto close10;}
        
      

 length = strlen(datacatalyst_name);
 datacatalyst_name[length-16]=0; /*** snip sendflag***/
 /*-t printf("\ndatcatalyst_name= %s", datacatalyst_name); */
 

    if ((strlen(codereq_name)+strlen(uprootdir))>63)
         { printf("\nToo many characters in requested file name."); 
           printf("\n %s ", codereq_name); goto close11;} 
 

     if ((strlen(datacatalyst_name)+strlen(uprootdir))>63)
         { printf("\nToo many characters in datacatalyst file name."); 
           printf("\n %s ", datacatalyst_name); goto close11; }
     

/****put varcatdir in front of datacatalyst_name***********/     
   
    
    for (i=0; i< 4; i++) 
     { lkdatacatalyst_name[i]= datacatalyst_name[i];}
    length = strlen(datacatalyst_name); /*make ldatacatalystname*/
    lkdatacatalyst_name[4]= 108;  /*--"l"--*/
    for (i=5; i< length+2; i++) 
     { lkdatacatalyst_name[i]= datacatalyst_name[i-1];}

    for (i=0; i< 4; i++) 
     { twodatacatalyst_name[i]= datacatalyst_name[i];}
    length = strlen(datacatalyst_name); /*make 2datacatalystname*/
    twodatacatalyst_name[4]= 116;  /*--"t"--*/
    for (i=5; i< length+2; i++) 
    { twodatacatalyst_name[i]= datacatalyst_name[i-1];}


    strcpy(tmpname, varcatdir);
    strcat(tmpname, lkdatacatalyst_name); /*add varcat dir */
    strcpy(lkdatacatalyst_name, tmpname);

    
    strcpy(tmpname, varcatdir);
    strcat(tmpname, twodatacatalyst_name); /*add varcat dir */
    strcpy(twodatacatalyst_name, tmpname);

    
    strcpy(tmpname, varcatdir);
    strcat(tmpname, datacatalyst_name); /*add varcat dir */
    strcpy(datacatalyst_name, tmpname);


/*-t printf("\n\n1- datcatalyst_name= %s", datacatalyst_name);
printf("\n1- lkdatcatalyst_name= %s", lkdatacatalyst_name);
printf("\n1- twodatcatalyst_name= %s\n", twodatacatalyst_name); */
/********/

       
/***********begin decoding file name***************************/

  for (i=0; i<66; i++)  /**init**/
   {  req_name[i]=0;  } 


/*-t printf("\ndatacatalyst_name length= %d", strlen(datacatalyst_name));*/

datacatalyst_file = fopen (datacatalyst_name ,"rb"); 
   if (datacatalyst_file == NULL ) 
       { puts("\n***can't open datacatalyst_file file***");
         printf("\n %s",datacatalyst_name); goto close11;  }  


    codenamelength= strlen(codereq_name);         
 /*-t printf("\ncodenamelength length= %d\n\n",codenamelength); */ 
    for (i=0; i<codenamelength; i++) 
      {  namedata=getc(datacatalyst_file);
               if (namedata== EOF)  
               {fclose (datacatalyst_file); 
                datacatalyst_file =fopen (datacatalyst_name, "rb"); 
                namedata=getc(datacatalyst_file);  }

         req_name[i]=(codereq_name[i]^i)^(namedata);   
         if (req_name[i]==0) {req_name[i]=codereq_name[i];} 
         enc1offset=codereq_name[i]&30;

         encloop=0;
         while (encloop<enc1offset)  
          { namedata=getc(datacatalyst_file);
           if (namedata== EOF)  
               {fclose (datacatalyst_file); 
                 datacatalyst_file =fopen (datacatalyst_name, "rb"); 
                 namedata=getc(datacatalyst_file);
                }
              /*-t printf(" %d",enc1offset); */ 
              --enc1offset; 
            }
                      
        /*-t printf("\ncodereq_name[i]= %d", codereq_name[i]);
         printf(" codereq_name= %s", codereq_name);
         printf("\n    req_name[i]= %d", req_name[i]);
         printf("      req_name= %s\n", req_name); */
       }
      
/**next three lines for testing only**/
   /*   length = strlen(req_name);  
        req_name[length-10]=35; 
        printf("\nreq_name= %s\n", req_name); */        

 length = strlen(req_name); loophelp=0;
 while (loophelp<16)  /**check for sendflag  flag**/
 {/*-t printf(" %c-%c", req_name[length-16+loophelp], sendflag[loophelp]);*/
   if(req_name[length-16+loophelp] != sendflag[loophelp])
     {printf("\nUnauthorized request to serve topssend.");        
        exit(0);}
   ++loophelp;  
   }

 req_name[length-16]=0; /*** snip sendflag***/
 /*-t printf("\nget %s", req_name); */
 
/***********end decoding file name******************************/
    
 
     
    strcpy(tmpname, uprootdir);
    strcat(tmpname , req_name); /*add root dir */
    strcpy(req_name, tmpname); 

   /*-t printf("\n2-req_name= %s\n", req_name); */   
/********/

    if(strstr(req_name, "//") != NULL )
    { printf("\n**Illegal ``//'' in or front of req_name file.**\n");
        printf("\nreq_name= %s ", req_name);
          goto close10;}

    if(strstr(req_name, "..") != NULL )
    { printf("\n**Illegal ``..'' in or front of req_name file.**\n");
         printf("\nreq_name= %s ", req_name);
          goto close10;}

    if(strstr(datacatalyst_name, "//") != NULL )
    { printf("\n**Illegal ``//'' in or front of datacatalyst_name file.**\n");
        printf("\ndatacatalyst_name= %s ", datacatalyst_name);
          goto close10;}
    
    if(strstr(datacatalyst_name, "..") != NULL )
    { printf("\n**Illegal ``..'' in or front of datacatalyst_name file.**\n");
        printf("\ndatacatalyst_name= %s ", datacatalyst_name);
           goto close10;}
    
/*------------------*/

    dirnamelength = strlen(varcatdir); 
    i=0;
    while ( i<dirnamelength)  
     {  /* printf("\n i= %d",i );
           printf(" req_name[i]= %c", req_name[i]);
           printf(" varcatdir[i]= %c", varcatdir[i]); */
       if (req_name[i] != varcatdir[i]) { goto cont110;} 
        ++i; }   
     printf("\n**File read access from ``Variable Catalyst 
Directory'' is not allowed ! **\n");       
     printf("varcatdir = %s\n", varcatdir);  
      goto close10;

cont110:

/*   i=0;
    while ( i<dirnamelength)  
     {    printf("\n i= %d",i );
          printf(" datacatalyst_name[i]= %c", datacatalyst_name[i]);
          printf(" varcatdir[i]= %c", varcatdir[i]);  
          ++i; }  */
      
     
cont111:
      printf("\nget from client: %s", req_name);
      printf("\nusing datacatalyst_name: %s\n", datacatalyst_name);  
    /*****************************************************/
  
/*-t printf("\nchecking if locked\n"); */
tries=10;              /*** 10 seconds to see unlock ***/ 
   while (tries > 0) 
    {--tries;
     fdlock= open(lkdatacatalyst_name, O_RDWR | O_CREAT | O_EXCL, 0444); 
     if (fdlock!=-1) {goto nolock20;} 
     
     sleep(1); printf("tries left= %d", tries);   
    }
  
  puts("\n***can't lock  datacatalyst file***"); 
  printf("\n\nlkdatacatalyst_name= %s", lkdatacatalyst_name);
  goto closelock10; 
 nolock20:
/*********/ 
     
    input_file = fopen(req_name,"wb");
    if (input_file == NULL ) 
         { puts("\n***can't open input file***");  
             printf("\nreq_name= %s ", req_name);       
           goto close10;    } 

      
    datacatalyst_file = fopen (datacatalyst_name ,"rb"); 
    if (datacatalyst_file == NULL ) 
            { puts("\n***can't open datacatalyst file***");
                 printf("\n %s ", datacatalyst_name);             
                     goto close10; }


   
     key2loophelp=0;   /*generate first time key2 only */
     while (key2loophelp < passlength -1 )
         { key2[key2loophelp] = password[key2loophelp+1]; 
            ++ key2loophelp;} 
     key2[key2loophelp]= password [0] ;

    /*-t printf("\n +key2=     %s", key2);
     printf("\n +password= %s",password);
     printf("\n +passlength= %d\n", passlength); */ 
 
/************read*********/
filesize=0; 

readsocket: 
   loophelp=0;
/*test printf("\n################new read#####filesize= %d\n", filesize); 
  printf("\n################new read#####loophelp= %d\n", loophelp); */

  
  for (i=0; i < bufsize/4; i++) {filebuf[i]=EOF;}  /* don't delete */
  if (recv(temp_sock_descriptor, filebuf, bufsize, 0) == -1)
   {perror("Error in receiving response from server\n"); exit(1); }
  
  
  while((filebuf[loophelp] != EOF)&&(loophelp<bufsize/4)) 
           {  

 /*   printf("%c",filebuf[loophelp]);  **these 3  for troubleshooting** 
   printf(" 1-filebuf[loophelp]= %d loophelp= %d", 
            filebuf[loophelp], loophelp);   */
   

   data=getc(datacatalyst_file);
   if (data== EOF)  
         {fclose (datacatalyst_file); 
          datacatalyst_file =fopen (datacatalyst_name, "rb"); 
          data=getc(datacatalyst_file);  }
  
  
  data= (data^loophelp)^passloop;  /*  hide data from simple code */


   /*   printf("\n data# before= %d ", data);
         printf("data char before= %c ", data);  */ 
 
    data= data^password[passloop];  
    data= data^key2[passloop];
    /* printf("\n data after= %d", data);
        printf(" password[passloop]=%c ", password[passloop]);
         printf(" passloop= %d ", passloop); */ 
   
   data = data^(filebuf[loophelp]);
   if (data != EOF) { filebuf[loophelp]= data; word[passloop]=data; }  
      else {word[passloop]=filebuf[loophelp];}
   
    /* printf("\n key2= %s", key2);
        printf("\n word= %s", word);
         printf("\n passlength= %d", passlength); */
    

  passloop++;  
  if (passloop == passlength) {
          for (i=0; i< passlength; i++) { key2[i]=word[i];} 
            passloop = 0 ;}   

         /**** catalyst offset for req file ****/
         enc1offset=filebuf[loophelp]&3;
         encloop=0;
         while (encloop<enc1offset)  
          { nonedata=getc(datacatalyst_file);
           if (nonedata== EOF)  
               {fclose (datacatalyst_file); 
                 datacatalyst_file =fopen (datacatalyst_name, "rb"); 
                 nonedata=getc(datacatalyst_file);
                }
                   /*printf(" %d",enc1offset); */ 
              --enc1offset; 	
            }
          /*****end offset for req file****/
     
   putc(filebuf[loophelp],input_file);   
                
         /*  printf(" filesize= %d",filesize);  */ 
                
               ++loophelp,++filesize; } 
  
  
        if (filebuf[loophelp] != EOF) 
          { --loophelp; goto readsocket;} 
 
  
        
 /*varcatmodevvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv*/  
      
  

  /*-t printf("\n2- datacatalyst name %s", datacatalyst_name);
  printf("\n2- twodatacatalyst_name %s", twodatacatalyst_name);
  printf("\n2- twodatacatalyst_namelength= %d",
strlen(twodatacatalyst_name));*/   
   fclose(input_file);
   fclose(datacatalyst_file); 
   

   input_file = fopen(req_name,"rb");
   if (input_file == NULL ) 
         { puts("\n***can't open input file for varcat***");
             printf("\nreq_name %s ", req_name);         
            goto endvarcatmode20;    } 

   datacatalyst_file = fopen (datacatalyst_name ,"rb"); 
   if (datacatalyst_file == NULL ) 
          { puts("\n***can't open datacatalyst file for varaat***");
              printf("\n %s ", datacatalyst_name);             
                     goto endvarcatmode20; }
    

   twodatacatalyst_file = fopen (twodatacatalyst_name ,"wb"); 
   if (twodatacatalyst_file == NULL ) 
     { puts("\n***can't write t-datacatalyst_name file***");
         printf("\ntwodatacatalyst_name= %s ", twodatacatalyst_name);
                                goto endvarcatmode20; }  


  /*-t printf("\nchanging catalyst : \n"); */
  offset=0; /* checksum=0; */
 while(( c = getc(datacatalyst_file) ) != EOF) 
     {  /* checksum=checksum+c; */
        data=getc(input_file);
          if (data== EOF)  
              {fclose (input_file); 
                 input_file = fopen(req_name,"rb");
                 if (input_file == NULL ) 
                     { puts("\n***can't re-open output file for varcat***"); 
                         printf("\nreq_name= %s ", req_name);  
                             goto close11; }
                   data=getc(input_file); 
                   if (data== EOF) {goto close11;}
                }
          
          --offset;   
          if (offset < 0) 
            { offset = (data&7);
                 /* printf("\noffset(databefore&7)= %x ", offset);
                  printf(" data= %x*%c ", data, data); */    
              data= data^c; 
                  /*printf(" dataafter(data^c)= %x ", data);
                    printf(" c= %x-%c \n",c ,c);  */ 

               if(data == EOF) { data = c; }
               putc( data , twodatacatalyst_file);   
               /* checksum = checksum + data; */   
             }
         else
          {   /* printf(" c# %x-%c ",c ,c ); */     
            putc( c, twodatacatalyst_file); 
                             }
           

    }
    
   /* printf("\nchecksum= %d", checksum); */

endvarcatmode20:
/*-t printf("\noreq_name= %s", req_name); */
/*endvarcatvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv*/
                
     
/* checksum2 */ 
        
  checksum2=0; checksum3=0;

   fclose(input_file);
   input_file = fopen (req_name ,"rb"); 
   if (input_file == NULL ) 
   { puts("\n***can't read input file for checksum3***");
        printf("\nreq+name= %s ", req_name);
                                goto close10; }  
     while(( c = getc(input_file)) != EOF) 
        { checksum3=checksum3+c;}


  fclose(twodatacatalyst_file);
  twodatacatalyst_file = fopen (twodatacatalyst_name ,"rb"); 
   if (twodatacatalyst_file == NULL ) 
     {puts("\n***can't read t-datacatalyst_name file for checksum2***");
         printf("\ntwodatacatalyst_name %s ", twodatacatalyst_name);     
                                goto close10; }  
  
     while(( c = getc(twodatacatalyst_file)) != EOF) 
        { checksum2=checksum2+c;}

  checksum1=checksum3+checksum2;
  /*-t printf("\nchecksum3= %ld", checksum3);  
  printf("\nchecksum2= %ld", checksum2);  
  printf("\nchecksum1= %d", checksum1); */
     	
/* end checksum2 */
 
/* send/get checksumx */

   
   /*-t printf("\nsending checksum1 info. \n"); */
    
   sprintf(checksumsend, "%ld",checksum1);
   printf("\nchecksumsend = %s", checksumsend);    
 
          
   for (i=0; i< 66; i++) { checksumget[i] = 0; }     
   if (recv(temp_sock_descriptor, checksumget, 10, 0) ==-1)   
          { perror("\ncall to recv checksumget fail"); goto close10; } 
 

 printf("\nchecksumget=   %s",checksumget);     
 
 length= strlen(checksumsend);
 /*-t printf("\nlength= %d", length); */
 for (i=0; i< length; i++) 
 { if(checksumget[i] != checksumsend[i])
    {printf("\n checksum fail, bad file/transfer or bad catalyst.\n");
      printf("\nsleep 5\n"); sleep(5); 
      for (i=0; i<10; i++) {checksumsend[i]=69;}
      if (send(temp_sock_descriptor, checksumsend, 10, 0) == -1) 
           { perror("\ncall to send checksumsend fail"); goto close10; }
           goto close10;
     } 
  }
 
 if (send(temp_sock_descriptor, checksumsend, 10, 0) == -1) 
           { perror("\ncall to send checksumsend fail"); goto close10; }
      

/* end send/get checksumx */

/*start write updated datacatalyst*/

   
   fclose(datacatalyst_file); 
   datacatalyst_file = fopen (datacatalyst_name ,"wb"); 
   if (datacatalyst_file == NULL ) 
          { puts("\n***can't write datacatalyst file for update***");
              printf("\n %s ", datacatalyst_name);             
                     goto close11; }
    
   fclose(twodatacatalyst_file);
   twodatacatalyst_file = fopen (twodatacatalyst_name ,"rb"); 
   if (twodatacatalyst_file == NULL ) 
     { puts("\n***can't read t-datacatalyst_name for update***");
         printf("\ntwodatacatalyst_name= %s ", twodatacatalyst_name);
                                goto close11; }  
 
  
 while(( c = getc(twodatacatalyst_file) ) != EOF) 
         { putc( c, datacatalyst_file); }   
 
/*end write updated datacatalyst*/

/* start verify written catalyst */
/*
checksum4=0;
   fclose(datacatalyst_file); 
   datacatalyst_file = fopen (datacatalyst_name ,"rb"); 
   if (datacatalyst_file == NULL ) 
          { puts("\n***can't read datacatalyst file for verify***");
              printf("\n %s ", datacatalyst_name); 
                  goto close11; }
     
   while(( c = getc(datacatalyst_file) ) != EOF) 
         { checksum4=checksum4+c; }

   if(checksum4 != checksum2)
      {printf("\n Error during catalyst verify.");        
       goto close11;}

  */
/* end verify written catalyst */


close10:

   fclose(input_file);
   fclose(datacatalyst_file);
   fclose(twodatacatalyst_file);
    
closelock10:
   (void)close(fdlock);
   (void)unlink(lkdatacatalyst_name);
   /*-t printf("\ntries left= %d", tries); */
   
close11:   
   
   close(temp_sock_descriptor);
   
   /*-t printf("\nEnd-loophelp is =%d",loophelp); */ 
   printf("    filesize is = %d \n",filesize);
   passloop=0; filesize=0; loophelp=0; dirflag=0; 

   exit(0); 
     } /*+++++++++++*/    
  else { close(temp_sock_descriptor);  } /*+++++++++*/ 
     }
} /*main**/
